// ChildView.cpp : CChildView Ŭ  
//

#include "stdafx.h"
#include "CommTimer.h"
#include "ChildView.h"
#include "CommTimeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	m_ComPortSel = 0;
}

CChildView::~CChildView()
{
	CloseHandle(h_CommHandle);
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_COMMAND(ID_SET_TIMEOUT_DLG, OnSetTimeoutDlg)
	ON_COMMAND(ID_READ, OnRec)
	ON_COMMAND_RANGE(ID_SEL_COM1,ID_SEL_COM4, OnSelCom)
	ON_UPDATE_COMMAND_UI_RANGE(ID_SEL_COM1, ID_SEL_COM3, OnUpdateSelCom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView ޼ ڵ鷯

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	if(FALSE == CommOpen(m_ComPortSel))
	{
		MessageBox ("Ʈ  ","",MB_OK);
		return FALSE;
	}		

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // ׸ ̽ ؽƮ
	
	// TODO: ޼ ڵ鷯 ڵ带 ⿡ ߰
	
	// ׸⸦  CWnd::OnPaint ȣؼ ȵ
}


void CChildView::OnSetTimeoutDlg() 
{
	COMMTIMEOUTS	CommTimeout;
	CCommTimeDlg	TimeSetDlg;

	GetCommTimeouts(h_CommHandle, &CommTimeout);

	TimeSetDlg.m_ReadIntervalTimeout = CommTimeout.ReadIntervalTimeout;
	TimeSetDlg.m_ReadTotalTimeoutMultiplier = CommTimeout.ReadTotalTimeoutMultiplier;
	TimeSetDlg.m_ReadTotalTimeoutConstant = CommTimeout.ReadTotalTimeoutConstant;

	if(TimeSetDlg.DoModal() == IDOK)
	{
		CommTimeout.ReadIntervalTimeout = TimeSetDlg.m_ReadIntervalTimeout ;
		CommTimeout.ReadTotalTimeoutMultiplier = TimeSetDlg.m_ReadTotalTimeoutMultiplier;
		CommTimeout.ReadTotalTimeoutConstant = TimeSetDlg.m_ReadTotalTimeoutConstant;

		SetCommTimeouts(h_CommHandle,&CommTimeout);
	}
}

void CChildView::OnSelCom(UINT nID) 
{
	CloseHandle(h_CommHandle);
	if(FALSE == CommOpen(nID - ID_SEL_COM1))
	{
		MessageBox ("Ʈ  ","",MB_OK);
		CommOpen(m_ComPortSel);
	}		
	else
	{
		m_ComPortSel = nID - ID_SEL_COM1;
	}
}

void CChildView::OnUpdateSelCom(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ComPortSel== pCmdUI->m_nID - ID_SEL_COM1);
}

BOOL CChildView::CommOpen(UINT CommPort)
{
	CString	PortName;

	PortName.Format("COM%d", CommPort + 1);
	h_CommHandle = CreateFile(PortName, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	if( h_CommHandle== INVALID_HANDLE_VALUE)
		return FALSE;
	else
		return TRUE;
}


void CChildView::OnRec() 
{
	CClientDC	dc(this);
	CString		Time;	
	char		RecBuff[200];
	DWORD		ReadLen;
	DWORD		After,Before;
	
	dc.TextOut(10, 10, "                   ");
	Before = GetTickCount();
	ReadFile(h_CommHandle, RecBuff, 100, &ReadLen, NULL);
	After =  GetTickCount();
	Time.Format("óð %d msec              ",After - Before);
	dc.TextOut(10, 10, Time);
}
